//
// cgmin.h
//

#ifndef __CGMIN_H__
#define __CGMIN_H__

typedef          int    WORD;
typedef unsigned long   DWORD;
typedef double          REAL;

typedef          int    bool;
#define false 0
#define true  1

//
// prototypes of force.c
//

REAL pot_force(REAL *y, REAL *g);
REAL dRho( REAL r );
REAL rho( REAL r );
REAL dU( REAL dens );
REAL u( REAL dens );
REAL dPhi( REAL r );
REAL phi( REAL r );

//
// prototypes of cgmin.c
//

REAL *ralloc (DWORD  size);
REAL  lin_energy (REAL *y, REAL *f, REAL  gamma, REAL *lin_force);
void mnbrak (REAL  *y, REAL *f, REAL  *ax, REAL  *bx, REAL  *cx,
	     REAL  *fa, REAL *fb, REAL  *fc);
REAL dbrent (REAL  *y, REAL *f, REAL ax, REAL bx, REAL cx, 
	     REAL tol, REAL *xmin);
void line_minimum (REAL *y, REAL *f, REAL *S);
void find_minimum (REAL *y, REAL *ymin, REAL *Smin, REAL *grad, DWORD *niter);

//
// prototypes of cell.c
//

void cellAlloc( int hn, double s );
void cellFree();
void cellUpdate(double *y);
void cellInit( bool genCp );
void cellReset();
bool cellCheck();
bool cellGen();

#endif //__CGMIN_H__
